
?-ensure_loaded(lib_sets).
?-ensure_loaded(lib_compatibility_for_swi).


delta_sets(StartStates, Delta, Symbol, TargetStates):-
   findall(Target, (member(Start,StartStates),member([Start,Symbol,Target],Delta)), TargetStateList),
   make_set(TargetStateList, TargetStates).



nfa_to_set_dfa(nfa(QN,Sigma,DeltaN,FN,SN),LastAddedStateSets,dfa(QTemp,Sigma,DeltaTemp,F,S),dfa(QDFA,SigmaDFA,DeltaDFA,FDFA,SDFA)):-
   findall( [OldStateSet,Symbol,NewStateSet], (                                      /* DeltaNext */
      member(OldStateSet,LastAddedStateSets),
      member(Symbol,Sigma),
      delta_sets(OldStateSet,DeltaN,Symbol,NewStateSet)
      ), NewDelta ),
   append(NewDelta, DeltaTemp, DeltaNextList),
   remove_doubles(DeltaNextList,DeltaNext),
   not(DeltaNext = DeltaTemp),

   findall(AddedStateSet, member([_,_,AddedStateSet], NewDelta), AddedStateSetList), /* QNext */
   append(AddedStateSetList,QTemp,QNextList),
   remove_doubles(QNextList, QNext),

   !,

   nfa_to_set_dfa(nfa(QN,Sigma,DeltaN,FN,SN), AddedStateSetList,
                  dfa(QNext,Sigma,DeltaNext,F,S),
                  dfa(QDFA,SigmaDFA,DeltaDFA,FDFA,SDFA)).
nfa_to_set_dfa(_,_,DFA,DFA).



set_dfa_to_dfa(dfa(QSets,Sigma,DeltaSets,SSet,FSet),dfa(Q,Sigma,Delta,S,F)):-
   findall(Pos, (member(_,Pos,QSets)), Q),
   findall([Start,Symbol,Target],(member([StartSet,Symbol,TargetSet],DeltaSets),member(StartSet,Start,QSets),member(TargetSet,Target,QSets)),Delta),
   member(SSet,S,QSets),
   findall(Pos,(member(FinalState,FSet),member(FinalState,Pos,QSets)),F).

nfa_to_dfa(nfa(Q,Sigma,Delta,S,F), DFA):-
   nfa_to_set_dfa(nfa(Q,Sigma,Delta,S,F), [[S]], dfa([[S]],Sigma,[],_,_) , dfa(QSets,Sigma,DeltaSets,_,_)),
   findall(State, (member(State,QSets),set_intersection(State,F,[_|_])), FSets),
   set_dfa_to_dfa(dfa(QSets,Sigma,DeltaSets,[S],FSets),  DFA).




