
?-ensure_loaded(lib_sets).


power_to_product(X,1,X):-!.
power_to_product(X,N,X*Y):-
   N1 is N-1,
   power_to_product(X,N1,Y).


/*                      +MinIndex, -MaxIndex : */
regexp_to_epsilon_nfa(X, MinIndex, MaxIndex, epsilon_nfa(Q,Sigma,Delta,Epsilon,S,F)):-
   atomic(X),
   MaxIndex is MinIndex+2,
   TempIndex is MinIndex+1,
   Q = [MinIndex,TempIndex],
   Sigma = [X],
   Delta = [[MinIndex,X,TempIndex]],
   Epsilon = [],
   S = MinIndex,
   F = [TempIndex].


regexp_to_epsilon_nfa(X*Y, MinIndex, MaxIndex, epsilon_nfa(Q,Sigma,Delta,Epsilon,S,F)):-
   regexp_to_epsilon_nfa(X, MinIndex, MaxIndex1, epsilon_nfa(Q1,Sigma1,Delta1,Epsilon1,S,F1)),
   regexp_to_epsilon_nfa(Y, MaxIndex1, MaxIndex, epsilon_nfa(Q2,Sigma2,Delta2,Epsilon2,S2,F)),
  
   append(Q1,Q2,Q),                                           /* Q*/
   append(Sigma1,Sigma2,SigmaList),                           /* Sigma */
   remove_doubles(SigmaList,Sigma),
   append(Delta1,Delta2,Delta),                               /* Delta */

   findall([End1State,S2],member(End1State,F1),Epsilon1to2),  /* Epsilon */
   append(Epsilon1,Epsilon2,EpsilonA),
   append(EpsilonA,Epsilon1to2,Epsilon).


regexp_to_epsilon_nfa(X+Y, MinIndex, MaxIndex, epsilon_nfa(Q,Sigma,Delta,Epsilon,S,F)):-
   regexp_to_epsilon_nfa(X, MinIndex, MaxIndex1, epsilon_nfa(Q1,Sigma1,Delta1,Epsilon1,S1,F1)),
   regexp_to_epsilon_nfa(Y, MaxIndex1, MaxIndex2, epsilon_nfa(Q2,Sigma2,Delta2,Epsilon2,S2,F2)),
   MaxIndex is MaxIndex2+1,
   append([MaxIndex2|Q1],Q2,Q),                                        /* Q*/
   append(Sigma1,Sigma2,SigmaList),                                    /* Sigma */
   remove_doubles(SigmaList,Sigma),
   append(Delta1,Delta2,Delta),                                        /* Delta */
   append([[MaxIndex2,S1],[MaxIndex2,S2]|Epsilon1],Epsilon2,Epsilon),  /* Epsilon */
   S = MaxIndex2,                                                      /* S */
   append(F1,F2,F).                                                    /* F */


regexp_to_epsilon_nfa(X^Y,MinIndex,MaxIndex,NFA):-
   integer(Y),
   Y > 1,
   power_to_product(X,Y,Product),
   regexp_to_epsilon_nfa(Product,MinIndex,MaxIndex,NFA).


/* S = neuer startzustand */
/* maxindex1 = neuer endzustand */
regexp_to_epsilon_nfa(X^Y, MinIndex, MaxIndex, epsilon_nfa(Q,Sigma,Delta,Epsilon,S,F)):-
   var(Y),
   regexp_to_epsilon_nfa(X,MinIndex,MaxIndex1, epsilon_nfa(Q1,Sigma,Delta,Epsilon1,S1,F1)),
   S is MaxIndex1+1,
   MaxIndex is S+1,
   
   Q = [S,MaxIndex1|Q1],
   findall([FinalState,MaxIndex1],member(FinalState,F1),Epsilon1ToEnd),
   append([[MaxIndex1,S],[S,MaxIndex1],[S,S1]|Epsilon1],Epsilon1ToEnd,Epsilon),
   F = [MaxIndex1].


regexp_to_epsilon_nfa([A], MinIndex, MaxIndex, epsilon_nfa([MaxIndex1,MaxIndex2|Q1],Sigma,Delta,Epsilon,MaxIndex1,[MaxIndex2])):-
   regexp_to_epsilon_nfa(A,MinIndex, MaxIndex2, epsilon_nfa(Q1,Sigma,Delta,Epsilon1,S,F1)):-
   MaxIndex1 is MaxIndex2+1,
   MaxIndex is MaxIndex1+1,
   findall([FElement,MaxIndex2], member(FElement,F1), AdditionalEpsilons),
   append([[MaxIndex1,S],[MaxIndex1,MaxIndex2]|AdditionalEpsilons],Epsilon1,Epsilon).


regexp_to_epsilon_nfa(REGEXP, EPSILON_NFA):-
   regexp_to_epsilon_nfa(REGEXP, 0, _, EPSILON_NFA).












