
/* ?-ensure_loaded(lib_pseudo_imperative). */


dfa_to_c(DFAname,dfa(Q,_,Delta,StartState,FinalStates)):-
   write('bool '), write(DFAname), write('(std::string word) {'), nl,
   write('   int i = 0;'), nl,
   write('   goto state'), write(StartState), write('; // go to start-state'), nl,nl,
   forall(member(State,Q),(
      write('   state'),write(State),write(':'),nl,
      write('      if(i >= word.length())'),nl,
      if(member(State,FinalStates),
         write('         return(true); // final state'),
         write('         return(false); // not a final state')
      ),nl,
      write('      switch(word[i++]) {'),nl,
      forall(member([State,Symbol,TransitionTarget],Delta),(
         write('         case \''),write(Symbol),write('\': goto state'),write(TransitionTarget),write(';'),nl
      )),
      write('         default : return false;'),nl,
      write('      }'),nl,nl
   )),
   write('}'),nl,!.


create_main_program(DFAname, DFA):-
   write('#include<iostream>'),nl,nl,nl,
   dfa_to_c(DFAname,DFA),nl,nl,
   write('int main(int argc, char** argv) {'),nl,
   write('   std::string input;'),nl,
   write('   if(argc > 1)'),nl,
   write('      input = argv[1];'),nl,
   write('   else'),nl,
   write('      std::cin >> input;'),nl,nl,
   write('   return '),write(DFAname),write('(input) ? 0 : 1;'), nl,
   write('}'),nl,!.






nfa_to_c(NFAname,nfa(Q,Sigma,Delta,StartState,[FirstFinalState|RestFinalStates])):-
   write('bool '),write(NFAname),write('(std::string word) {'),nl,
   length(Q,StateCount),
   write('   int StateCount = '),write(StateCount),write(';'),nl,
   write('   bool *CurrentStates = new(bool[StateCount]);'),nl,
   write('   bool *NextStates = new(bool[StateCount]);'),nl,
   write('   bool *StateSwapTemp;'),nl,
   write('   for(int j = 0; j < StateCount; j++){'),nl,
   write('      CurrentStates[j] = false;'),nl,
   write('      NextStates[j] = false;'),nl,
   write('   }'),nl,
   member(StartState,StartStatePos,Q),
   write('   CurrentStates['),write(StartStatePos),write('] = true; // StartState'),nl,nl,
   
   
   write('   for(int i = 0; i < word.length(); i++) {'),nl,
   forall(member(State,Pos,Q),(
      write('      if(CurrentStates['),write(Pos),write(']){'),nl,   
      write('         switch(word[i]){'),nl,
      forall(member(Symbol,Sigma),(
         write('            case \''),write(Symbol),write('\':'),nl,
         forall(member([State,Symbol,Target],Delta),(
            member(Target,TargetPos,Q),
            write('               NextStates['),write(TargetPos),write('] = true;'),nl
         )),
         write('               break;'),nl
      )),
      write('         }'),nl,
      write('      }'),nl,nl
   )),
   write('   StateSwapTemp = NextStates;'),nl,
   write('   NextStates = CurrentStates;'),nl,
   write('   CurrentStates = StateSwapTemp;'),nl,
   write('   for(int j = 0; j < StateCount; j++)'),nl,
   write('      NextStates[j] = false;'),nl,
   write('   }'),nl,nl,
   
   write('   bool result = ('),nl,
   member(FirstFinalState,FirstFinalPos,Q),
   write('                 CurrentStates['),write(FirstFinalPos),write(']'),nl,
   forall(member(FinalState,RestFinalStates),(
      member(FinalState,FinalStatePos,Q),
      write('              || CurrentStates['),write(FinalStatePos),write(']'),nl
   )),
   write('                 );'),nl,
   write('   delete[](CurrentStates);'),nl,
   write('   delete[](NextStates);'),nl,
   write('   return result;'),nl,
   write('}'),nl,
   !.















