
?-ensure_loaded(lib_pseudo_imperative).
?-ensure_loaded(lib_compatibility_for_swi).


epsilon_nfa_to_latex(epsilon_nfa(Q,_,Delta,Epsilon,S,F)):-

   RasterX is 15,
   RasterY is 25,
   Width is 120,
   XCount is Width//RasterX-1,                      /* */
   length(Q,Length),
   Height is (Length//XCount)*RasterY+RasterY,    /* */


   nl,nl,
   write('% this document was generated by Prolog AutomataTheory SYstem (PATSY)'),nl,
   write('% PATSY is distributed under the terms of the GNU General Public'),nl,
   write('% License (GPL) v2. See GPL.txt for further details. Have Fun and may'),nl,
   write('% the source be with you!'),nl,
   write('%                         05/20/2007,  Viktor "AlgorithMan" Engelmann'),nl,
   write('%                                                  www.AlgorithMan.de'),nl,nl,

   write('% don\'t forget to download the gastex package!'),nl,
   write('% (PATSY was tested with gastex 2.7)'),nl,
   write('% http://www.lsv.ens-cachan.fr/~gastin/gastex/gastex.html'),nl,nl,

   write('% you might also want to use JasTeX to adjust the positions'),nl,
   write('% of the states in a WYSIWYG editor'),nl,
   write('% http://www.lsv.ens-cachan.fr/~gastin/JasTeX/JasTeX.html'),nl,nl,nl,


   write('\\documentclass{article}'),nl,
   write('\\usepackage[usenames]{color}'),nl,
   write('\\usepackage{gastex}'),nl,
   write('\\begin{document}'),nl,nl,

   write('\\begin{center}'),nl,
   write('\\begin{picture}('),write(Width),write(','), write(Height),write(')(0,0)'),nl,nl,

   forall(member(State,Pos,Q),(
      XPos is (Pos mod XCount)*RasterX+RasterX,
      YPos is Height-(Pos // XCount)*RasterY-(RasterY//2),                    /* */
      if((member(State,F),State=\=S),
         (write('  \\node[Nmarks=r](STATE'),write(State),write(')('),write(XPos),write(','),write(YPos),write('){'),write(State),write('}'),nl),
      /*else*/
         if((member(State,F),State=S),
            (write('  \\node[Nmarks=ir](STATE'),write(State),write(')('),write(XPos),write(','),write(YPos),write('){'),write(State),write('}'),nl),
         /*else*/
            if(State=S,
               (write('  \\node[Nmarks=i](STATE'),write(State),write(')('),write(XPos),write(','),write(YPos),write('){'),write(State),write('}'),nl),
            /*else*/
               (write('  \\node(STATE'),write(State),write(')('),write(XPos),write(','),write(YPos),write('){'),write(State),write('}'),nl)
            )
         )
      )
   )),

   forall((member([Start,Symbol,Target],Delta),Start=\=Target),(
      write('  \\drawedge(STATE'),write(Start),write(',STATE'),write(Target),write('){$'),write(Symbol), write('$}'),nl
   )),

   forall(member([LoopStart,Symb,LoopStart],Delta),(
      write('  \\drawloop[loopangle=90](STATE'),write(LoopStart), write('){$'),write(Symb), write('$}'),nl
   )),

   forall((member([EpsStart,EpsTarget],Epsilon),EpsStart=\=EpsTarget),(
      write('  \\drawedge(STATE'),write(EpsStart),write(',STATE'),write(EpsTarget),write('){$\\varepsilon$}'),nl
   )),

   nl,
   write('\\end{picture}'),nl,
   write('\\end{center}'),nl,
   write('\\end{document}'),nl.


nfa_to_latex(nfa(Q,_,Delta,S,F)):-
   epsilon_nfa_to_latex(epsilon_nfa(Q,_,Delta,[],S,F)).

dfa_to_latex(dfa(Q,_,Delta,S,F)):-
   epsilon_nfa_to_latex(epsilon_nfa(Q,_,Delta,[],S,F)).

